Debian Bug report logs - #451222
libjpeg: mass bug filing for cross build support

version graph

Package: libjpeg6b; Maintainer for libjpeg6b is Bill Allombert <ballombe@debian.org>;

Reported by: Neil Williams <codehelp@debian.org>

Date: Wed, 14 Nov 2007 09:03:01 UTC

Severity: wishlist

Tags: patch

Fixed in version libjpeg7/7-1

Done: Bill Allombert <ballombe@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
New Bug report received and forwarded. Copy sent to Bill Allombert <ballombe@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: submit@bugs.debian.org
Subject: libjpeg: mass bug filing for cross build support
Date: Wed, 14 Nov 2007 09:02:02 +0000
[Message part 1 (text/plain, inline)]
Package: libjpeg6b
Version: 6b-14
Severity: wishlist
Tags: patch
User: codehelp@debian.org
Usertags: crossbuilt

--- Please enter the report below this line. ---

As part of the long term mass bug filing for cross building support,
(http://lists.debian.org/debian-devel/2007/11/msg00116.html), I've
prepared this patch for debian/rules.

The cross building support in Debian has been recently rewritten -
particularly in respect of how environment variables and overrides are
handled - so this patch is now needed to allow libjpeg6b to correctly
identify the cross compiler.

The patch also wraps 'make check' in a test for the 'nocheck'
DEB_BUILD_OPTION and prevents the replacement of the original 'libtool'
script when cross-compiling (the wrapper created by the package fails
to pass the correct tags to the cross compiler; using the original
script allows the cross build environment to handle the libtool call).

Note that libjpeg6b needs to be told about the cross-compiler in
--build and --host as well as in the $(CC) variable to configure, it
also requires $(CC) to be set to the cross compiler for each of the
$(MAKE) commands. I suspect this is related to #346126.

I can split these out into other bugs if you prefer but all changes
affect the same file and achieve the same purpose: supporting cross
building.

Please consider implementing this patch. Thanks.

--- libjpeg6b-6b/debian/rules 
+++ libjpeg6b.new/debian/rules 
@@ -6,6 +6,13 @@
 
 export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+
+ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
+CROSS=CC=$(DEB_HOST_GNU_TYPE)-gcc
+confflags= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE) $(CROSS)
+else
+confflags= --build $(DEB_BUILD_GNU_TYPE)
+endif
 
 include debian/patch.mk
 
@@ -16,6 +23,12 @@
 CFLAGS += -O2
 endif
 
+ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
+CHECK=
+else
+CHECK=$(MAKE) test
+endif
+
 #export DH_VERBOSE=1
 
 build: build-stamp 
@@ -23,11 +36,13 @@
 	dh_testdir
 	./configure --prefix=/usr --mandir=usr/share/man \
 	 --enable-static --enable-shared --enable-maxmem=1024 \
-	 --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE) 
+	 $(confflags) 
+ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
 	printf '#!/bin/sh\nexec libtool "$$@"\n' >libtool
-	$(MAKE)
-	$(MAKE) test
-	$(MAKE) -C debian/extra
+endif
+	$(MAKE) $(CROSS)
+	$(CHECK)
+	$(MAKE) -C debian/extra $(CROSS)
 
 	touch build-stamp
 


--- System information. ---
Architecture: amd64
Kernel:       Linux 2.6.22-2-amd64

Debian Release: lenny/sid
  500 unstable        www.linux.codehelp.co.uk 
  500 unstable        www.emdebian.org 
  500 unstable        ftp.uk.debian.org 

--- Package information. ---
Depends       (Version) | Installed
=======================-+-===========
                        | 




-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. Full text and rfc822 format available.

Message #10 received at 451222@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Neil Williams <codehelp@debian.org>, 451222@bugs.debian.org
Subject: Re: Bug#451222: libjpeg: mass bug filing for cross build support
Date: Fri, 7 Dec 2007 23:11:05 +0100
On Wed, Nov 14, 2007 at 09:02:02AM +0000, Neil Williams wrote:
> Package: libjpeg6b
> Version: 6b-14
> Severity: wishlist
> Tags: patch
> User: codehelp@debian.org
> Usertags: crossbuilt
> 
> --- Please enter the report below this line. ---
> 
> As part of the long term mass bug filing for cross building support,
> (http://lists.debian.org/debian-devel/2007/11/msg00116.html), I've
> prepared this patch for debian/rules.
> 
> The patch also wraps 'make check' in a test for the 'nocheck'
> DEB_BUILD_OPTION and prevents the replacement of the original 'libtool'
> script when cross-compiling (the wrapper created by the package fails
> to pass the correct tags to the cross compiler; using the original
> script allows the cross build environment to handle the libtool call).

Hello Neil,

I do not understand how do that work given than the original libtool
script is not able to build the package.

> Note that libjpeg6b needs to be told about the cross-compiler in
> --build and --host as well as in the $(CC) variable to configure, it
> also requires $(CC) to be set to the cross compiler for each of the
> $(MAKE) commands. I suspect this is related to #346126.
> 
> I can split these out into other bugs if you prefer but all changes
> affect the same file and achieve the same purpose: supporting cross
> building.
> 
> Please consider implementing this patch. Thanks.

Did you check this patch actually allow libjpeg to be cross-compiled ?
If yes, how did you proceed ?

(Personnally I use distcc+crosscc+an emulator to cross build packages
This is extremly reliable and does not require any changes to packages
build scripts but it is slower than true cross-compiling because some
part run inside the emulator). 

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. Full text and rfc822 format available.

Message #15 received at 451222@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
Cc: 451222@bugs.debian.org
Subject: Re: Bug#451222: libjpeg: mass bug filing for cross build support
Date: Fri, 07 Dec 2007 22:29:37 +0000
[Message part 1 (text/plain, inline)]
Bill Allombert wrote:
> On Wed, Nov 14, 2007 at 09:02:02AM +0000, Neil Williams wrote:
>> Package: libjpeg6b
>> Version: 6b-14
>> Severity: wishlist
>> Tags: patch
>> User: codehelp@debian.org
>> Usertags: crossbuilt
>>
>> --- Please enter the report below this line. ---
>>
>> As part of the long term mass bug filing for cross building support,
>> (http://lists.debian.org/debian-devel/2007/11/msg00116.html), I've
>> prepared this patch for debian/rules.
>>
>> The patch also wraps 'make check' in a test for the 'nocheck'
>> DEB_BUILD_OPTION and prevents the replacement of the original 'libtool'
>> script when cross-compiling (the wrapper created by the package fails
>> to pass the correct tags to the cross compiler; using the original
>> script allows the cross build environment to handle the libtool call).
> 
> Hello Neil,
> 
> I do not understand how do that work given than the original libtool
> script is not able to build the package.

The patched source is capable of building natively and cross - tested
prior to filing the bug report.

>> Note that libjpeg6b needs to be told about the cross-compiler in
>> --build and --host as well as in the $(CC) variable to configure, it
>> also requires $(CC) to be set to the cross compiler for each of the
>> $(MAKE) commands. I suspect this is related to #346126.
>>
>> I can split these out into other bugs if you prefer but all changes
>> affect the same file and achieve the same purpose: supporting cross
>> building.
>>
>> Please consider implementing this patch. Thanks.
> 
> Did you check this patch actually allow libjpeg to be cross-compiled ?
> If yes, how did you proceed ?

http://www.emdebian.org/packages/search.php?arch=arm&distro=unstable&package=libjpeg62

http://buildd.emdebian.org/svn/browser/current/target/trunk/l/libjpeg6b/trunk/libjpeg6b_6b-14em1_arm.build

> (Personnally I use distcc+crosscc+an emulator to cross build packages
> This is extremly reliable and does not require any changes to packages
> build scripts but it is slower than true cross-compiling because some
> part run inside the emulator). 

Emdebian will not be using emulators - it's all to be cross built from
Debian sources. I also disagree on the reliability of emulators but
that's by the by.

http://www.emdebian.org/

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/


[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. Full text and rfc822 format available.

Message #20 received at 451222@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Neil Williams <codehelp@debian.org>
Cc: 451222@bugs.debian.org
Subject: Re: Bug#451222: libjpeg: mass bug filing for cross build support
Date: Sun, 9 Dec 2007 22:57:18 +0100
On Fri, Dec 07, 2007 at 10:29:37PM +0000, Neil Williams wrote:
> Bill Allombert wrote:
> > On Wed, Nov 14, 2007 at 09:02:02AM +0000, Neil Williams wrote:
> >> Package: libjpeg6b
> >> Version: 6b-14
> >> Severity: wishlist
> >> Tags: patch
> >> User: codehelp@debian.org
> >> Usertags: crossbuilt
> >>
> >> --- Please enter the report below this line. ---
> >>
> >> As part of the long term mass bug filing for cross building support,
> >> (http://lists.debian.org/debian-devel/2007/11/msg00116.html), I've
> >> prepared this patch for debian/rules.
> >>
> >> The patch also wraps 'make check' in a test for the 'nocheck'
> >> DEB_BUILD_OPTION and prevents the replacement of the original 'libtool'
> >> script when cross-compiling (the wrapper created by the package fails
> >> to pass the correct tags to the cross compiler; using the original
> >> script allows the cross build environment to handle the libtool call).
> > 
> > Hello Neil,
> > 
> > I do not understand how do that work given than the original libtool
> > script is not able to build the package.
> 
> The patched source is capable of building natively and cross - tested
> prior to filing the bug report.

This is nice, but I still do not understand how that work. The original
libtool script has tons of issues (wrong runpath setting, missing
platforms supports, etc.) . How do you avoid them ? Are you replacing it
by some fixed libtool script automatically ?

> >> Note that libjpeg6b needs to be told about the cross-compiler in
> >> --build and --host as well as in the $(CC) variable to configure, it
> >> also requires $(CC) to be set to the cross compiler for each of the
> >> $(MAKE) commands. I suspect this is related to #346126.
> >>
> >> I can split these out into other bugs if you prefer but all changes
> >> affect the same file and achieve the same purpose: supporting cross
> >> building.
> >>
> >> Please consider implementing this patch. Thanks.
> > 
> > Did you check this patch actually allow libjpeg to be cross-compiled ?
> > If yes, how did you proceed ?
> 
> http://www.emdebian.org/packages/search.php?arch=arm&distro=unstable&package=libjpeg62
> 
> http://buildd.emdebian.org/svn/browser/current/target/trunk/l/libjpeg6b/trunk/libjpeg6b_6b-14em1_arm.build

That does not tell me how you proceed. I would really like to try it
for myself, else I am likely to break cross-building support in a 
subsequent upload. For example this package is supposed to be
cross-buildable using scratchbox (according to the scratchbox people).
If I apply your patch, will that still work ?

> Emdebian will not be using emulators - it's all to be cross built from
> Debian sources. I also disagree on the reliability of emulators but
> that's by the by.

Well you can replace the emulator by real hardware in my setup.

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. Full text and rfc822 format available.

Message #25 received at 451222@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
Cc: 451222@bugs.debian.org
Subject: Re: Bug#451222: libjpeg: mass bug filing for cross build support
Date: Sun, 09 Dec 2007 22:30:51 +0000
[Message part 1 (text/plain, inline)]
Bill Allombert wrote:
> On Fri, Dec 07, 2007 at 10:29:37PM +0000, Neil Williams wrote:
>> Bill Allombert wrote:
>>> On Wed, Nov 14, 2007 at 09:02:02AM +0000, Neil Williams wrote:
>>>> As part of the long term mass bug filing for cross building support,
>>>> (http://lists.debian.org/debian-devel/2007/11/msg00116.html), I've
>>>> prepared this patch for debian/rules.
>>>>
>>>> The patch also wraps 'make check' in a test for the 'nocheck'
>>>> DEB_BUILD_OPTION and prevents the replacement of the original 'libtool'
>>>> script when cross-compiling (the wrapper created by the package fails
>>>> to pass the correct tags to the cross compiler; using the original
>>>> script allows the cross build environment to handle the libtool call).
>>> Hello Neil,
>>>
>>> I do not understand how do that work given than the original libtool
>>> script is not able to build the package.
>> The patched source is capable of building natively and cross - tested
>> prior to filing the bug report.
> 
> This is nice, but I still do not understand how that work.

Because your replacement code is preserved if not cross compiling.

> The original
> libtool script has tons of issues (wrong runpath setting, missing
> platforms supports, etc.) . How do you avoid them ? Are you replacing it
> by some fixed libtool script automatically ?

We'll fix those when we come up against them. Have you reported that
upstream? Are the issues documented anywhere?

The fact is that your replacement libtool is just as broken, from a
cross build perspective. I prefer to debug a libtool that actually
builds a package rather than waste time on emulator issues and a libtool
that cannot cross build.

Emdebian will also be using the OpenEmbedded patches to see what else
may need changing. For now, I'm just concentrating on getting a package
that builds so that Emdebian can test those other changes. We may use
the WRAP_LIBTOOL variable to provide a more usable libtool, for example.

What matters to me is that the conditionals are added:
(email line wrapping notwithstanding)

+ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
+CROSS=CC=$(DEB_HOST_GNU_TYPE)-gcc
+confflags= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
$(CROSS)
+WRAP_LIBTOOL=
+else
+confflags= --build $(DEB_BUILD_GNU_TYPE)
+WRAP_LIBTOOL=printf '#!/bin/sh\nexec libtool "$$@"\n' >libtool
+endif
+

and

+ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
+CHECK=
+else
+CHECK=$(MAKE) test
+endif
+

with the code that supports those:

+        $(confflags)
+       $(WRAP_LIBTOOL)
+       $(MAKE) $(CROSS)
+       $(CHECK)
+       $(MAKE) -C debian/extra $(CROSS)

None of that affects how Debian builds the package and I don't see that
it would affect scratchbox either as the package has no cross build
support currently anyway.

>>>>
>>>> Please consider implementing this patch. Thanks.
>>> Did you check this patch actually allow libjpeg to be cross-compiled ?
>>> If yes, how did you proceed ?
>> http://www.emdebian.org/packages/search.php?arch=arm&distro=unstable&package=libjpeg62
>>
>> http://buildd.emdebian.org/svn/browser/current/target/trunk/l/libjpeg6b/trunk/libjpeg6b_6b-14em1_arm.build
> 
> That does not tell me how you proceed.

$ sudo apt-get install emdebian-tools
Choose "arm" as your default architecture for dpkg-cross
$ emsetup -v
installs the emdebian arm toolchain
$ emsource -v libjpeg6b
and cd to the build directory, then
$ emdebuild -v

or just use
$ emsource -v -b libjpeg6b

(all using -v|--verbose because it helps you see what is going on,
normally automated builds use --quiet).

The manpages, www.emdebian.org and the wiki pages should fill in the gaps.

> I would really like to try it
> for myself, else I am likely to break cross-building support in a 
> subsequent upload. 

You'll get a bug report from the Emdebian autobuild systems if that
happens. Don't worry.
:-)

> For example this package is supposed to be
> cross-buildable using scratchbox (according to the scratchbox people).
> If I apply your patch, will that still work ?

The patch only affects cross building. Scratchbox doesn't cross build,
it builds with emulation. A scratchbox build pretends that the build
machine is the host architecture and then scrabbles around in the
emulator trying to stop the program finding out the truth.

>> Emdebian will not be using emulators - it's all to be cross built from
>> Debian sources. I also disagree on the reliability of emulators but
>> that's by the by.
> 
> Well you can replace the emulator by real hardware in my setup.

The real hardware cannot run a compiler, that's why Emdebian cross
builds! We're targetting 32Mb iPAQ's and smaller. There's no point
thinking about replacing the emulator with the device for Emdebian - the
real device does not have the resources.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/


[signature.asc (application/pgp-signature, attachment)]

Reply sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
You have taken responsibility. (Mon, 25 May 2009 18:36:04 GMT) Full text and rfc822 format available.

Notification sent to Neil Williams <codehelp@debian.org>:
Bug acknowledged by developer. (Mon, 25 May 2009 18:36:04 GMT) Full text and rfc822 format available.

Message #30 received at 451222-done@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Neil Williams <codehelp@debian.org>, 451222-done@bugs.debian.org
Subject: Re: Bug#451222: libjpeg: mass bug filing for cross build support
Date: Mon, 25 May 2009 20:33:55 +0200
[Message part 1 (text/plain, inline)]
On Wed, Nov 14, 2007 at 09:02:02AM +0000, Neil Williams wrote:
> Package: libjpeg6b
> Version: 6b-14
> Severity: wishlist
> Tags: patch
> User: codehelp@debian.org
> Usertags: crossbuilt
> 
> --- Please enter the report below this line. ---
> 
> As part of the long term mass bug filing for cross building support,
> (http://lists.debian.org/debian-devel/2007/11/msg00116.html), I've
> prepared this patch for debian/rules.

As I said before your patch is wrong and I am not inclined to argue
the point anymore, so I am closing this bug. There is no need to
NMU libjpeg to include this broken patch. 

I apologize not to have done that sooner.

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. (Mon, 25 May 2009 19:06:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. (Mon, 25 May 2009 19:06:02 GMT) Full text and rfc822 format available.

Message #35 received at 451222@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Bill.Allombert@math.u-bordeaux1.fr, 451222@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#451222: libjpeg: mass bug filing for cross build support
Date: Mon, 25 May 2009 20:03:38 +0100
[Message part 1 (text/plain, inline)]
reopen 451222
thanks

I was having a really good day until I got this:

> > As part of the long term mass bug filing for cross building support,
> > (http://lists.debian.org/debian-devel/2007/11/msg00116.html), I've
> > prepared this patch for debian/rules.
> 
> As I said before your patch is wrong and I am not inclined to argue
> the point anymore, so I am closing this bug. 

What is the point of closing a bug without a fix? The package will not
cross-build and the change makes no difference to the Debian package.

> There is no need to
> NMU libjpeg to include this broken patch. 

Well I'll have to NMU the package to fix the cross-build. It can't be
left as-is.

The patch is not wrong - it works just fine and it is completely
insulated from the Debian builds.

> I apologize not to have done that sooner.

That doesn't help me and Emdebian. The package still fails to
cross-build outside your emulator tests.

The libtool handling used in the Debian package prevents cross-building,
the Emdebian patch fixes it, simple as that.

> I do not understand how do that work given than the original libtool
> script is not able to build the package.

During the cross-build, supporting scripts provide a replacement
libtool setup that has none of the problems you've described. 

> Did you check this patch actually allow libjpeg to be cross-compiled ?

Of course, all patches are only created after a successful cross-build
and this has also been tested on real Emdebian devices.

Yes. It was released as part of Emdebian Crush 1.0 based on Debian 5.0.

> If yes, how did you proceed ?

Applied the patch, cross-built the package with emdebian-tools and
uploaded it to Emdebian Crush. Installed it, works fine.

The patch has been tested and the cross-built package is just fine.

Emulation is simply not acceptable. The package can cross-build just
fine with the emdebian-tools setup. It doesn't even need the
workarounds that some other packages need for old, broken, libtools.

rpath is not an issue for Emdebian - I don't care what happens with it,
it simply doesn't matter within the context of Emdebian installations.

I'm attaching the latest version of the Emdebian Crush patch.

I still intend to NMU using the attached patch.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[emdebian-rules.patch (text/x-diff, attachment)]
[Message part 3 (application/pgp-signature, inline)]

Bug reopened, originator not changed. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Mon, 25 May 2009 19:06:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. (Mon, 25 May 2009 19:36:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. (Mon, 25 May 2009 19:36:02 GMT) Full text and rfc822 format available.

Message #42 received at 451222@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Bill.Allombert@math.u-bordeaux1.fr
Cc: 451222@bugs.debian.org
Subject: rpath is not set in the cross-built files
Date: Mon, 25 May 2009 20:27:12 +0100
[Message part 1 (text/plain, inline)]
$ dpkg-architecture -aarm -c "debc /opt/emdebian/trunk/l/libjpeg6b/trunk/libjpeg6b_6b-14em1_arm.changes"
..
  This is an Emdebian Crush package.
 
drwxr-xr-x root/root         0 2009-05-25 19:58 ./
drwxr-xr-x root/root         0 2009-05-25 19:57 ./usr/
drwxr-xr-x root/root         0 2009-05-25 19:58 ./usr/lib/
-rw-r--r-- root/root    127384 2009-05-25 19:57 ./usr/lib/libjpeg.so.62.0.0
drwxr-xr-x root/root         0 2009-05-25 19:57 ./usr/share/
drwxr-xr-x root/root         0 2009-05-25 19:57 ./usr/share/doc/
drwxr-xr-x root/root         0 2009-05-25 19:58 ./usr/share/doc/libjpeg62/
-rw-r--r-- root/root      2261 2009-05-25 19:48 ./usr/share/doc/libjpeg62/copyright.gz
lrwxrwxrwx root/root         0 2009-05-25 19:58 ./usr/lib/libjpeg.so.62 -> libjpeg.so.62.0.0

neil@holly:libjpeg6b-6b$ readelf -d .libs/libjpeg.so.62.0.0|grep RPATH
neil@holly:libjpeg6b-6b$


neil@holly:libjpeg6b-6b$ file .libs/libjpeg.so.62.0.0
.libs/libjpeg.so.62.0.0: ELF 32-bit LSB shared object, ARM, version 1, dynamically linked, not stripped

Emdebian Crush doesn't use the libjpeg-progs_6b-14em1_arm.deb package,
only the shared library matters.

neil@holly:libjpeg6b-6b$ readelf -d ./debian/libjpeg-progs/usr/bin/cjpeg|grep RPATH
 0x0000000f (RPATH)                      Library rpath: [/usr/lib]

In the context of Emdebian Crush, that is fine too. Many of the issues
surrounding rpath in Debian just don't apply with embedded devices -
often because you haven't got people fiddling around with binaries in
unusual places. However, I really can't see any need for any Emdebian
device to install libjpeg-progs - none of my desktop systems have it.

You haven't precisely described the actual issues you are using to
discount this bug report and I've done what I can to show that the
patch allows the package to cross-build without any ill effects, either
in Debian or Emdebian. AFAICT there is no basis for using arguments
based on RPATH because it plainly is not a problem.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. (Tue, 26 May 2009 22:39:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. (Tue, 26 May 2009 22:39:10 GMT) Full text and rfc822 format available.

Message #47 received at 451222@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Neil Williams <codehelp@debian.org>, 451222@bugs.debian.org
Subject: Re: Bug#451222: libjpeg: mass bug filing for cross build support
Date: Wed, 27 May 2009 00:35:59 +0200
On Mon, May 25, 2009 at 08:03:38PM +0100, Neil Williams wrote:
> reopen 451222
> thanks
> 
> I was having a really good day until I got this:

Good for you!

> > > As part of the long term mass bug filing for cross building support,
> > > (http://lists.debian.org/debian-devel/2007/11/msg00116.html), I've
> > > prepared this patch for debian/rules.
> > 
> > As I said before your patch is wrong and I am not inclined to argue
> > the point anymore, so I am closing this bug. 
> 
> What is the point of closing a bug without a fix? The package will not
> cross-build and the change makes no difference to the Debian package.

This never was a bug: your report does not state any packaging requirement that
this package fails to meet, only one you made up. So it is a wishlist item,
accompanied by a broken patch.

Furthermore, this issue will be fixed with a new sourceful upload, which is the
only sane way to fix the build system. This is delayed in the hope of a new
upstream version in July. 

> > There is no need to
> > NMU libjpeg to include this broken patch. 

> The patch is not wrong - it works just fine and it is completely
> insulated from the Debian builds.

You mean the patch you sent *today* ? How was I supposed to apply it before?
Anyway I refuse to apply any patch which cause the upstream libtool
to be used in any way.

> rpath is not an issue for Emdebian - I don't care what happens with it,
> it simply doesn't matter within the context of Emdebian installations.

But I do, because this is a policy requirement.

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. (Tue, 26 May 2009 22:42:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. (Tue, 26 May 2009 22:42:02 GMT) Full text and rfc822 format available.

Message #52 received at 451222@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Neil Williams <codehelp@debian.org>
Cc: 451222@bugs.debian.org
Subject: Re: rpath is not set in the cross-built files
Date: Wed, 27 May 2009 00:39:36 +0200
On Mon, May 25, 2009 at 08:27:12PM +0100, Neil Williams wrote:
> Emdebian Crush doesn't use the libjpeg-progs_6b-14em1_arm.deb package,
> only the shared library matters.
> 
> neil@holly:libjpeg6b-6b$ readelf -d ./debian/libjpeg-progs/usr/bin/cjpeg|grep RPATH
>  0x0000000f (RPATH)                      Library rpath: [/usr/lib]
> 
> You haven't precisely described the actual issues you are using to
> discount this bug report and I've done what I can to show that the
> patch allows the package to cross-build without any ill effects, either
> in Debian or Emdebian. AFAICT there is no basis for using arguments
> based on RPATH because it plainly is not a problem.

Not a problem for you, but it might be a problem for someone else that
crossbuild the package. An rpath of /usr/lib is a clear policy violation.

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. (Wed, 27 May 2009 10:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. (Wed, 27 May 2009 10:03:03 GMT) Full text and rfc822 format available.

Message #57 received at 451222@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
Cc: 451222@bugs.debian.org
Subject: Re: rpath is not set in the cross-built files
Date: Wed, 27 May 2009 11:00:17 +0100
[Message part 1 (text/plain, inline)]
On Wed, 27 May 2009 00:39:36 +0200
Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr> wrote:

> On Mon, May 25, 2009 at 08:27:12PM +0100, Neil Williams wrote:
> > Emdebian Crush doesn't use the libjpeg-progs_6b-14em1_arm.deb package,
> > only the shared library matters.
> > 
> > neil@holly:libjpeg6b-6b$ readelf -d ./debian/libjpeg-progs/usr/bin/cjpeg|grep RPATH
> >  0x0000000f (RPATH)                      Library rpath: [/usr/lib]
> > 
> > You haven't precisely described the actual issues you are using to
> > discount this bug report and I've done what I can to show that the
> > patch allows the package to cross-build without any ill effects, either
> > in Debian or Emdebian. AFAICT there is no basis for using arguments
> > based on RPATH because it plainly is not a problem.
> 
> Not a problem for you, but it might be a problem for someone else that
> crossbuild the package. An rpath of /usr/lib is a clear policy violation.

Only of Debian Policy but Debian Policy does not make any claims about
cross-built packages because cross-building isn't the way that Debian
builds packages. (Cross-built packages are not welcome in the archive.)

Emdebian has our own Policy which departs from Debian Policy in certain
areas - one of which is rpath. The simple reason is that the problems
that rpath causes in Debian are not applicable within an embedded
system. rpath is a fact of life in the embedded world, there is no
use-case for removing it and no problems caused by retaining it in a
system built from cross-built packages. Indeed, in many ways, Emdebian
*requires* rpath to be set in some circumstances. See:
http://wiki.debian.org/EmdebianPolicy

Besides, as shown in the output, the rpath is only set in the programs
in the -tools package which, again, is of no relevance to Emdebian or
other embedded deployments. 
-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. (Wed, 27 May 2009 10:06:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. (Wed, 27 May 2009 10:06:06 GMT) Full text and rfc822 format available.

Message #62 received at 451222@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
Cc: 451222@bugs.debian.org
Subject: Re: Bug#451222: libjpeg: mass bug filing for cross build support
Date: Wed, 27 May 2009 11:03:59 +0100
[Message part 1 (text/plain, inline)]
On Wed, 27 May 2009 00:35:59 +0200
Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr> wrote:

> Furthermore, this issue will be fixed with a new sourceful upload, which is the
> only sane way to fix the build system. This is delayed in the hope of a new
> upstream version in July. 

How realistic is that hope?
 
> > > There is no need to
> > > NMU libjpeg to include this broken patch. 
> 
> > The patch is not wrong - it works just fine and it is completely
> > insulated from the Debian builds.
> 
> You mean the patch you sent *today* ? How was I supposed to apply it before?

The patch is essentially the same as the one previously sent - I just
tweaked it a bit for readability. The effect of the patch is completely
unchanged.

> Anyway I refuse to apply any patch which cause the upstream libtool
> to be used in any way.

On what basis? The change is never enacted within Debian.

> > rpath is not an issue for Emdebian - I don't care what happens with it,
> > it simply doesn't matter within the context of Emdebian installations.
> 
> But I do, because this is a policy requirement.

A Policy requirement that applies to Debian but Debian does not accept
packages that are cross-built and the rpath only shows up *IF* the
package is cross-built so there is no problem here.

It is Emdebian Policy that rpath *is* set in some circumstances, as
explained in my other email.

This patch does *not* change the Debian build, it does not introduce
rpath into the Debian packages and it does not break Debian Policy.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Bill Allombert <ballombe@debian.org>:
Bug#451222; Package libjpeg6b. (Sat, 13 Jun 2009 13:06:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Bill Allombert <ballombe@debian.org>. (Sat, 13 Jun 2009 13:06:05 GMT) Full text and rfc822 format available.

Message #67 received at 451222@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Neil Williams <codehelp@debian.org>, 451222@bugs.debian.org
Subject: Re: Bug#451222: libjpeg: mass bug filing for cross build support
Date: Sat, 13 Jun 2009 15:02:49 +0200
On Wed, May 27, 2009 at 11:03:59AM +0100, Neil Williams wrote:
> On Wed, 27 May 2009 00:35:59 +0200
> Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr> wrote:
> 
> > Furthermore, this issue will be fixed with a new sourceful upload, which is the
> > only sane way to fix the build system. This is delayed in the hope of a new
> > upstream version in July. 
> 
> How realistic is that hope?

Current schedule call for the final release on 27-June-2009.
there is a release candidate available for testing, which should
be final.

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Tags added: pending Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Mon, 06 Jul 2009 08:06:04 GMT) Full text and rfc822 format available.

Reply sent to Bill Allombert <ballombe@debian.org>:
You have taken responsibility. (Mon, 10 Aug 2009 21:51:08 GMT) Full text and rfc822 format available.

Notification sent to Neil Williams <codehelp@debian.org>:
Bug acknowledged by developer. (Mon, 10 Aug 2009 21:51:08 GMT) Full text and rfc822 format available.

Message #74 received at 451222-close@bugs.debian.org (full text, mbox):

From: Bill Allombert <ballombe@debian.org>
To: 451222-close@bugs.debian.org
Subject: Bug#451222: fixed in libjpeg7 7-1
Date: Mon, 10 Aug 2009 21:32:04 +0000
Source: libjpeg7
Source-Version: 7-1

We believe that the bug you reported is fixed in the latest version of
libjpeg7, which is due to be installed in the Debian FTP archive:

libjpeg-progs_7-1_amd64.deb
  to pool/main/libj/libjpeg7/libjpeg-progs_7-1_amd64.deb
libjpeg7-dbg_7-1_amd64.deb
  to pool/main/libj/libjpeg7/libjpeg7-dbg_7-1_amd64.deb
libjpeg7-dev_7-1_amd64.deb
  to pool/main/libj/libjpeg7/libjpeg7-dev_7-1_amd64.deb
libjpeg7_7-1.diff.gz
  to pool/main/libj/libjpeg7/libjpeg7_7-1.diff.gz
libjpeg7_7-1.dsc
  to pool/main/libj/libjpeg7/libjpeg7_7-1.dsc
libjpeg7_7-1_amd64.deb
  to pool/main/libj/libjpeg7/libjpeg7_7-1_amd64.deb
libjpeg7_7.orig.tar.gz
  to pool/main/libj/libjpeg7/libjpeg7_7.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 451222@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Bill Allombert <ballombe@debian.org> (supplier of updated libjpeg7 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 05 Jul 2009 15:29:27 +0200
Source: libjpeg7
Binary: libjpeg7 libjpeg7-dev libjpeg7-dbg libjpeg-progs
Architecture: source amd64
Version: 7-1
Distribution: unstable
Urgency: low
Maintainer: Bill Allombert <ballombe@debian.org>
Changed-By: Bill Allombert <ballombe@debian.org>
Description: 
 libjpeg-progs - Programs for manipulating JPEG files
 libjpeg7   - The Independent JPEG Group's JPEG runtime library
 libjpeg7-dbg - Development files for the IJG JPEG library
 libjpeg7-dev - Development files for the IJG JPEG library
Closes: 346126 451222 535350
Changes: 
 libjpeg7 (7-1) unstable; urgency=low
 .
   * The "Yoan" release.
   * New upstream release. closes: #535350
     - This release includes configure.ac and Makefile.am. closes: #346126
     - All patches merged upstream.
     - Remove dpatch support.
   * debian/control:
     - Remove Build-Dependency on libtool and sharutils.
     - Move libjpeg7-dbg to debug section.
     - Bump standard version to 3.8.2.
   * Skip test-suite if nocheck is set. closes: #451222
Checksums-Sha1: 
 2cfebf369819de1bb5b7fc249cf2c199608570dd 985 libjpeg7_7-1.dsc
 88cced0fc3dbdbc82115e1d08abce4e9d23a4b47 960379 libjpeg7_7.orig.tar.gz
 b346d8f7803d08feccade84a0012a48ee2b5f62e 11554 libjpeg7_7-1.diff.gz
 4d5178da5b84c96b5f70cf0eea169fae2b2bf047 126076 libjpeg7_7-1_amd64.deb
 e346f7bde90c753a8cea4db666daa5e0ee31ae04 230800 libjpeg7-dev_7-1_amd64.deb
 036f972ab73e7d569ce6d2d5e9b789a12420b6e6 295994 libjpeg7-dbg_7-1_amd64.deb
 bc52d0f6b576c031c62fe591f5e4c2ca87e409c0 82888 libjpeg-progs_7-1_amd64.deb
Checksums-Sha256: 
 36731e59ecb3461a0e121e9eb3bb53633ea1cc97d593df0091e9ef3e499177cd 985 libjpeg7_7-1.dsc
 50b7866206c5be044c4a2b0d7895898f5a58d31b50e16e79cf7dea3b90337ebf 960379 libjpeg7_7.orig.tar.gz
 e465ab295502c6db995780d3b2e38570794d0d31034f0065352bcbda63c3a094 11554 libjpeg7_7-1.diff.gz
 a08fef9763cf10fdad24c062757cf6a300656ea06d03d913c61aaeebda96a15e 126076 libjpeg7_7-1_amd64.deb
 18155b2860f1764e060f46f261a688cc2fa03de4cacd6c80eb644910c9d29057 230800 libjpeg7-dev_7-1_amd64.deb
 f1dc0539eb9b4eb342a6647b7e0e33bbddf1e42a17b7a926a3628f544057288f 295994 libjpeg7-dbg_7-1_amd64.deb
 39940fb8cad4cf9746ba1b131bc8217ca8fb3e16eaf9bb2603410b3e8abc5b5f 82888 libjpeg-progs_7-1_amd64.deb
Files: 
 d67508057ada7f9e69849fea92f5351a 985 graphics optional libjpeg7_7-1.dsc
 382ef33b339c299b56baf1296cda9785 960379 graphics optional libjpeg7_7.orig.tar.gz
 cf3fcb9d0a363586ef9f2e28c1e0ef8a 11554 graphics optional libjpeg7_7-1.diff.gz
 b5c2f618cbf8932cf1a9bc708da0bcaf 126076 libs optional libjpeg7_7-1_amd64.deb
 1352d1090c9ed10876c3c31875140d37 230800 libdevel optional libjpeg7-dev_7-1_amd64.deb
 ba62e06a1ac136978a89d28f3e42b044 295994 debug extra libjpeg7-dbg_7-1_amd64.deb
 f344c8504099950356b37e5feb49a738 82888 graphics optional libjpeg-progs_7-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkpRGfQACgkQeDPs8bVESBWOGgCfd5pLXbN/1jebA9KSRQaOiFd2
tC0An2fDiqGLw5XeYmajX4Ei6iTdTWqX
=MQ0Q
-----END PGP SIGNATURE-----





No longer marked as found in versions 6b-14. Request was from Andreas Beckmann <anbe@debian.org> to control@bugs.debian.org. (Mon, 04 Nov 2013 00:09:08 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 02 Dec 2013 07:31:38 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 16:02:58 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.